clear;
clc;
load('BC(569_30).mat')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
class_set = unique(gnd)';
kk = length(class_set);
[fea,gnd]=slect(kk,fea,gnd);
X=fea';
clear geneID geneSym Y
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m,n]=size(X);
fea=X;
options = [];
options.NeighborMode = 'KNN';
options.k =5;
options.WeightMode = 'Binary';
% options.WeightMode = 'HeatKernel';
% options.t = 1e+3;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ws = constructW(fea,options);
Wp = constructW(fea',options);
Ds=diag(sum(Ws));
Dp=diag(sum(Wp));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
NIter=20;
beta=100;
alpha=100;
lambda=800;
p=15;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:200
    tic
    [P,S,X_2]=DFSC(X,Ds,Ws,Dp,Wp,alpha,beta,lambda,p,NIter);
    label=kmeans(X_2',kk,'emptyaction','singleton');
    warning off all
    toc
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    newres = bestMap(gnd,label);
    AC = length(find(gnd == newres))/length(gnd);
    MIhat=MutualInfo(gnd,label);
    resualt(i,:)=[AC,MIhat];
    disp(resualt(i,:));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:2
    a=resualt(:,j);
    ll=length(a);
    temp=[];
    for i=1:ll
        if i<=ll/2
            b=sum(a(i:i+ll/2-1));
            temp=[temp;b];
        end
    end
    [e,f]=max(temp);
    Iwant(j,:)=[e,f];
end
disp(Iwant);